// Code generated by gobind. DO NOT EDIT.

// Java class com.proton.gopenpgp.srp.Server is a proxy for talking to a Go program.
//
//   autogenerated by gobind -lang=java -javapkg=com.proton.gopenpgp github.com/ProtonMail/go-srp
package com.proton.gopenpgp.srp;

import go.Seq;

/**
 * Server stores the internal state for the validation of SRP proofs.
 */
public final class Server implements Seq.Proxy {
	static { Srp.touch(); }
	
	private final int refnum;
	
	@Override public final int incRefnum() {
	      Seq.incGoRef(refnum, this);
	      return refnum;
	}
	
	/**
	 * NewServer creates a new server instance from the raw binary data.
	 */
	public Server(byte[] modulusBytes, byte[] verifier, long bitLength) {
		this.refnum = __NewServer(modulusBytes, verifier, bitLength);
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewServer(byte[] modulusBytes, byte[] verifier, long bitLength);
	
	/**
	 * NewServerFromSigned creates a new server instance from the signed modulus and the binary verifier.
	 */
	public Server(String signedModulus, byte[] verifier, long bitLength) {
		this.refnum = __NewServerFromSigned(signedModulus, verifier, bitLength);
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewServerFromSigned(String signedModulus, byte[] verifier, long bitLength);
	
	/**
	 * NewServerWithSecret creates a new server instance without generating a random secret from the raw binary data.
	Use with caution as the secret should not be reused.
	 */
	public Server(byte[] modulusBytes, byte[] verifier, byte[] secretBytes, long bitLength) {
		this.refnum = __NewServerWithSecret(modulusBytes, verifier, secretBytes, bitLength);
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewServerWithSecret(byte[] modulusBytes, byte[] verifier, byte[] secretBytes, long bitLength);
	
	Server(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
	
	/**
	 * GenerateChallenge is the first step for SRP exchange, and generates a valid challenge for the provided verifier.
	 */
	public native byte[] generateChallenge() throws Exception;
	/**
	 * GetSharedSession returns the shared secret as byte if the session has concluded in valid state.
	 */
	public native byte[] getSharedSession() throws Exception;
	/**
	 * IsCompleted returns true if the exchange has been concluded in valid state.
	 */
	public native boolean isCompleted();
	/**
	 * VerifyProofs Verifies the client proof and - if valid - generates the shared secret and returnd the server proof.
	It concludes the exchange in valid state if successful.
	 */
	public native byte[] verifyProofs(byte[] clientEphemeralBytes, byte[] clientProofBytes) throws Exception;
	@Override public boolean equals(Object o) {
		if (o == null || !(o instanceof Server)) {
		    return false;
		}
		Server that = (Server)o;
		return true;
	}
	
	@Override public int hashCode() {
	    return java.util.Arrays.hashCode(new Object[] {});
	}
	
	@Override public String toString() {
		StringBuilder b = new StringBuilder();
		b.append("Server").append("{");
		return b.append("}").toString();
	}
}

