// Code generated by gobind. DO NOT EDIT.

// Java class com.proton.gopenpgp.srp.Srp is a proxy for talking to a Go program.
//
//   autogenerated by gobind -lang=java -javapkg=com.proton.gopenpgp github.com/ProtonMail/go-srp
package com.proton.gopenpgp.srp;

import go.Seq;

public abstract class Srp {
	static {
		Seq.touch(); // for loading the native library
		_init();
	}
	
	private Srp() {} // uninstantiable
	
	// touch is called from other bound packages to initialize this package
	public static void touch() {}
	
	private static native void _init();
	
	
	public static final long ECDLPEphemeralSize = 24L;
	public static final String Version = "0.0.3";
	
	/**
	 * ErrDataAfterModulus found extra data after decode the modulus
	 */
	public static native void setErrDataAfterModulus(java.lang.Exception v);
	/**
	 * ErrDataAfterModulus found extra data after decode the modulus
	 */
	public static native java.lang.Exception getErrDataAfterModulus();
	
	/**
	 * ErrInvalidSignature invalid modulus signature
	 */
	public static native void setErrInvalidSignature(java.lang.Exception v);
	/**
	 * ErrInvalidSignature invalid modulus signature
	 */
	public static native java.lang.Exception getErrInvalidSignature();
	
	// skipped variable RandReader with unsupported type: io.Reader
	
	public static native long ecdlpChallenge(String b64Challenge) throws Exception;
	public static native String getModulusKey();
	/**
	 * HashPassword returns the hash of password argument. Based on version number
	following arguments are used in addition to password:
	* 0, 1, 2: userName and modulus
	* 3, 4: salt and modulus
	 */
	public static native byte[] hashPassword(long authVersion, byte[] password, String userName, byte[] salt, byte[] modulus) throws Exception;
	/**
	 * MailboxPassword get mailbox password hash
	
	Parameters:
		 - password []byte: a mailbox password
		 - salt []byte: a salt is random 128 bits data
	Returns:
	  - hashed []byte: a hashed password
	  - err error: throw error
	 */
	public static native byte[] mailboxPassword(byte[] password, byte[] salt) throws Exception;
	/**
	 * NewAuth Creates new Auth from strings input. Salt and server ephemeral are in
	base64 format. Modulus is base64 with signature attached. The signature is
	verified against server key. The version controls password hash algorithm.
	
	Parameters:
		 - version int: The *x* component of the vector.
		 - username string: The *y* component of the vector.
		 - password []byte: The *z* component of the vector.
		 - b64salt string: The std-base64 formatted salt
	Returns:
	  - auth *Auth: the pre calculated auth information
	  - err error: throw error
	Usage:
	
	Warnings:
		 - Be careful! Poos can hurt.
	 */
	public static native Auth newAuth(long version, String username, byte[] password, String b64salt, String signedModulus, String serverEphemeral) throws Exception;
	/**
	 * NewAuthForVerifier Creates new Auth from strings input. Salt and server ephemeral are in
	base64 format. Modulus is base64 with signature attached. The signature is
	verified against server key. The version controls password hash algorithm.
	
	Parameters:
		 - version int: The *x* component of the vector.
		 - username string: The *y* component of the vector.
		 - password []byte: The *z* component of the vector.
		 - salt string:
	Returns:
	  - auth *Auth: the pre calculated auth information
	  - err error: throw error
	Usage:
	
	Warnings:
		 - none.
	 */
	public static native Auth newAuthForVerifier(byte[] password, String signedModulus, byte[] rawSalt) throws Exception;
	/**
	 * NewServer creates a new server instance from the raw binary data.
	 */
	public static native Server newServer(byte[] modulusBytes, byte[] verifier, long bitLength) throws Exception;
	/**
	 * NewServerFromSigned creates a new server instance from the signed modulus and the binary verifier.
	 */
	public static native Server newServerFromSigned(String signedModulus, byte[] verifier, long bitLength) throws Exception;
	/**
	 * NewServerWithSecret creates a new server instance without generating a random secret from the raw binary data.
	Use with caution as the secret should not be reused.
	 */
	public static native Server newServerWithSecret(byte[] modulusBytes, byte[] verifier, byte[] secretBytes, long bitLength) throws Exception;
	public static native byte[] randomBits(long bits) throws Exception;
	public static native byte[] randomBytes(long byes) throws Exception;
	/**
	 * VersionNumber get current libaray version
	 */
	public static native String versionNumber();
}
